# -*- coding: utf-8 -*-

import wbfs2fat, cfg, sys

def checkconfig():
    if sys.platform == "cygwin" and cfg.options.rename and not cfg.options.fat_dir:
        confirm("Warning: drive_letter is required for automatic rename")
        cfg.options.rename=0
    if not cfg.options.backup:
        confirm("Warning: skipping backup")
    
def confirm(msg):
    if cfg.options.confirm:
        print msg
        try:
            raw_input("Press Enter to continue or Control+C to cancel")
        except KeyboardInterrupt:
            sys.exit(1)

def report(lvl,msg):
    if lvl<=cfg.options.verbosity: sys.stdout.write(msg)

def printwbfs(part):
    _, name, size, games, statust, status = wbfs2fat.scanwbfs(*part)
    if status == 0:
        cfg.report(0, name+" \t"+size+" \t"+str(games)+" Games \t"+statust+"\n")
    elif status in (5,6):
        cfg.report(1, name+" \t"+size+" \t"+str(games)+" Games \tERROR "+str(status)+" : "+statust+"\n")
    elif status in (4,7):
        cfg.report(1, name+" \tERROR "+str(status)+" : "+statust+"\n")
    elif status == 3:
        cfg.report(2, name+" \tERROR "+str(status)+" : "+statust+"\n")

cfg.report = report
cfg.confirm = confirm
