# -*- coding: utf-8 -*-

from PyQt4 import QtCore,  QtGui
from guiselect import GuiSelect
import cfg, sys

def startgui():
    app = QtGui.QApplication(sys.argv)
    cfg.ui = GuiSelect()
    cfg.ui.show()
    sys.exit(app.exec_())

def report(lvl, msg):
    if cfg.ui:
        if lvl <= cfg.options.verbosity:
            cfg.ui.plainTextEdit.insertPlainText(msg)
            cfg.ui.plainTextEdit.ensureCursorVisible()
            cfg.ui.repaint()

class MyTableModel(QtCore.QAbstractTableModel): 
    def __init__(self, datain, headerdata, parent=None, *args):
        QtCore.QAbstractTableModel.__init__(self, parent, *args)
        self.arraydata = datain
        self.headerdata = headerdata

    def rowCount(self, parent):
        return len(self.arraydata)

    def columnCount(self, parent):
        return len(self.arraydata[0])

    def data(self, index, role):
        if not index.isValid():
            return QtCore.QVariant()
        elif role != QtCore.Qt.DisplayRole:
            return QtCore.QVariant()
        return QtCore.QVariant(self.arraydata[index.row()][index.column()]) 

    def headerData(self, col, orientation, role):
        if orientation == QtCore.Qt.Horizontal and role == QtCore.Qt.DisplayRole:
            return QtCore.QVariant(self.headerdata[col])
        return QtCore.QVariant()

    def addRow(self, data):
        self.arraydata.append(data)
        self.layoutChanged.emit() 

    def getRow(self, index):
        return self.arraydata[index.row()]

cfg.report = report
