# -*- coding: utf-8 -*-

from PyQt4.QtCore import pyqtSignature
from Ui_guiconvert import Ui_GuiConvert

from PyQt4 import QtCore, QtGui
import wbfs2fat, cfg, sys

class GuiConvert(QtGui.QWidget, Ui_GuiConvert):
    def __init__(self, parent = None):
        QtGui.QWidget.__init__(self, parent)
        self.setupUi(self)
        self.back_dir.setText(cfg.options.back_dir)
        self.backup.setChecked(bool(cfg.options.backup))
        self.ren_dir.setText(cfg.options.fat_dir)
        self.rename.setChecked(bool(cfg.options.rename))
        self.verbosity.setValue(cfg.options.verbosity)
        self.ignore6.setChecked(bool(cfg.options.ignore6))
        if sys.platform == "linux2":
            self.fsck.setEnabled(1)
            self.fsck.setChecked(bool(cfg.options.fsck))
        self.checkoptions()

    def checkoptions(self, fix=0):
        self.plainTextEdit.clear()
        if sys.platform == "linux2":
            if cfg.options.rename and not cfg.options.fat_dir:
                self.plainTextEdit.appendPlainText("Warning: Mount Point is required for automatic rename")
                self.plainTextEdit.appendPlainText("Please select some directory where the partition can be mounted")
                self.plainTextEdit.appendPlainText("")
                if fix: cfg.options.fat_dir="./tmp"

        elif sys.platform == "cygwin":
            if cfg.options.rename and not cfg.options.fat_dir:
                self.plainTextEdit.appendPlainText("Warning: Mount Point is required for automatic rename!")
                self.plainTextEdit.appendPlainText("Please select the Windows Drive Letter of the partition.")
                self.plainTextEdit.appendPlainText("")
                if fix: cfg.options.rename=0

        if not cfg.options.backup:
            self.plainTextEdit.appendPlainText("Warning: skipping backup!")
            self.plainTextEdit.appendPlainText("Only do this if you are desperate.")
            self.plainTextEdit.appendPlainText("")

        elif not cfg.options.back_dir:
            self.plainTextEdit.appendPlainText("Warning: Backup Directory is required for backup!")
            self.plainTextEdit.appendPlainText("Please select some directory to store it.")
            self.plainTextEdit.appendPlainText("")
            if fix: cfg.options.back_dir="."

        if cfg.options.ignore6:
            self.plainTextEdit.appendPlainText("Warning: Manually overriding error 6 abort!")
            self.plainTextEdit.appendPlainText("Multiply used blocks will be duplicated")
            self.plainTextEdit.appendPlainText("Read the documentation on what this means")

    @pyqtSignature("bool")
    def on_backup_toggled(self, checked):
        cfg.options.backup = checked
        self.checkoptions()

    @pyqtSignature("bool")
    def on_rename_toggled(self, checked):
        if sys.platform != "win32":
            self.ren_label.setEnabled(checked)
            self.ren_dir.setEnabled(checked)
        if sys.platform == "linux2":
            self.ren_dialog.setEnabled(checked)
        cfg.options.rename = checked
        self.checkoptions()

    @pyqtSignature("")
    def on_ren_dialog_clicked(self):
        self.ren_dir.setText(QtGui.QFileDialog.getExistingDirectory(self, 'Select Directory', cfg.options.fat_dir))

    @pyqtSignature("")
    def on_back_dialog_clicked(self):
        self.back_dir.setText(QtGui.QFileDialog.getExistingDirectory(self, 'Select Directory',  cfg.options.back_dir))

    @pyqtSignature("")
    def on_buttonBox_accepted(self):
        self.optionBox.hide()
        self.buttonBox.setEnabled(0)
        self.checkoptions(1)
        self.plainTextEdit.clear()
        self.plainTextEdit.update()
        QtCore.QCoreApplication.processEvents()
        try:
            dev = wbfs2fat.Device(cfg.dev_name)
            dev.convert()
            self.buttonBox.setStandardButtons(QtGui.QDialogButtonBox.Close)
        except wbfs2fat.WbfsError as e:
            self.plainTextEdit.appendPlainText("ERROR "+str(e.args[0])+" : "+e.args[1])
            self.buttonBox.setStandardButtons(QtGui.QDialogButtonBox.Abort)
        except:
            self.plainTextEdit.appendPlainText("ERROR "+ str(sys.exc_info()[0]))
            self.buttonBox.setStandardButtons(QtGui.QDialogButtonBox.Abort)
        self.buttonBox.setEnabled(1)

    @pyqtSignature("")
    def on_buttonBox_rejected(self):
        self.close()

    @pyqtSignature("QString")
    def on_back_dir_textChanged(self, p0):
        cfg.options.back_dir = str(p0)
        self.checkoptions()

    @pyqtSignature("QString")
    def on_ren_dir_textChanged(self, p0):
        if sys.platform == "cygwin":
            cfg.options.fat_dir="/cygdrive/"+str(p0).split(":")[0][-1]
        else:
            cfg.options.fat_dir = str(p0)
        self.checkoptions()

    @pyqtSignature("int")
    def on_verbosity_valueChanged(self, p0):
        cfg.options.verbosity = p0
    
    @pyqtSignature("bool")
    def on_fsck_toggled(self, checked):
        cfg.options.fsck = checked
    
    @pyqtSignature("bool")
    def on_ignore6_toggled(self, checked):
        cfg.options. ignore6= checked
        self.checkoptions()
