# -*- coding: utf-8 -*-

from PyQt4.QtGui import QWidget
from PyQt4.QtCore import pyqtSignature
from Ui_guiselect import Ui_GuiSelect

from PyQt4 import QtGui
from guiconvert import GuiConvert
from guirestore import GuiRestore
import wbfs2fat, cfg, sys, gui, string

class GuiSelect(QWidget, Ui_GuiSelect):
    def __init__(self, parent = None):
        global options
        QWidget.__init__(self, parent)
        self.setupUi(self)
        self.model = gui.MyTableModel([wbfs2fat.scanwbfs(*part) for part in wbfs2fat.findparts()], ["Device", "Name", "Size", "Games", "Status", "Code"], self)
        self.table.setModel(self.model)
        self.table.hideColumn(0)
        self.table.hideColumn(5)
        if cfg.dev_name:
            dev = wbfs2fat.scanwbfs(cfg.dev_name)
            self.model.addRow(dev)
            self.table.selectRow(len(self.model.arraydata)-1)
            self.convert.setDisabled(dev[5] and dev[5]!=6)
            self.lineEdit.setText(dev[0])
        self.table.resizeColumnsToContents()
        self.table.resizeRowsToContents()

    @pyqtSignature("QModelIndex")
    def on_table_clicked(self, index):
        self.on_table_activated(index)

    @pyqtSignature("QModelIndex")
    def on_table_activated(self, index):
        dev = self.model.getRow(index)
        self.lineEdit.setText(dev[0])
        self.convert.setDisabled(dev[5] and dev[5]!=6)

    @pyqtSignature("")
    def on_scan_clicked(self):
        self.model.addRow(wbfs2fat.scanwbfs(str(self.lineEdit.text())))
        self.table.selectRow(len(self.model.arraydata)-1)
        self.table.resizeColumnsToContents()
        self.table.resizeRowsToContents()

    @pyqtSignature("")
    def on_restore_clicked(self):
        cfg.dev_name =  str(self.lineEdit.text())
        if sys.platform == "win32":
            cfg.options.fat_dir=string.lstrip(cfg.dev_name, "\.")[0]+":"
        cfg.ui = GuiRestore()
        self.close()
        cfg.ui.show()

    @pyqtSignature("")
    def on_convert_clicked(self):
        cfg.dev_name =  str(self.lineEdit.text())
        if sys.platform == "win32":
            cfg.options.fat_dir=string.lstrip(cfg.dev_name, "\.")[0]+":"
        cfg.ui = GuiConvert()
        self.close()
        cfg.ui.show()

    @pyqtSignature("")
    def on_buttonBox_rejected(self):
        self.close()

    @pyqtSignature("QString")
    def on_lineEdit_textEdited(self, p0):
        self.convert.setDisabled(1)
